// Atom.cs
using System;
using System.Reflection;


namespace TtLisp {
  public abstract class Atom : SymbolicExpression {
    public override SymbolicExpression ToEvaluated( Env env ) { return this; }
  }

  public class True : Symbol {
    // -- static ---------------------------------------------------------
    public static readonly True T = new True();

    // -- instance -------------------------------------------------------
    private True() : base( "t" ) {}
  }

  public class Nil : List, ISymbol {
    // -- static ---------------------------------------------------------
    public static new readonly Nil NIL = new Nil();

    // -- static ---------------------------------------------------------
    private Nil() : base ( Nil.NIL ) {
      typeof( List ).InvokeMember(
        "car",
        BindingFlags.SetField | BindingFlags.NonPublic | BindingFlags.Instance,
        null, this, new object[]{ this } );
      typeof( List ).InvokeMember(
        "cdr",
        BindingFlags.SetField | BindingFlags.NonPublic | BindingFlags.Instance,
        null, this, new object[]{ this } );
    }

    public string Name { get { return "nil"; } }

    public override SymbolicExpression ToEvaluated( Env env ) {
      return this;
    }

    public override string ToString() {
      return "nil";
    }
  }

}
