// FunctionTable.cs
using System;
using System.Collections;

namespace TtLisp {
  public class FunctionTable : IEnumerable {
    private Hashtable self;

    public FunctionTable() {
      self = new Hashtable();
    }

    public virtual int Count { get { return self.Count; } }
    public virtual bool IsSynchronized { get { return self.IsSynchronized; } }

    public virtual Function this[ISymbol key] {
      get {
        if ( this.ContainsKey( key ) ) {
          return (Function)self[key.Name];
        }
        else {
          throw new FunctionIsNotDefinedException();
        }
      }
    }

    public virtual ICollection Keys { get { return self.Keys; } }
    public virtual object SyncRoot { get { return self.SyncRoot; } }
    public virtual ICollection Values { get { return self.Values; } }

    public virtual void Define( ISymbol key, Function value ) {
      this.self[key.Name] = value;
    }
    public virtual bool ContainsKey( ISymbol key ) {
      return self.ContainsKey( key.Name );
    }
    public virtual bool ContainsValue( Function value ) {
      return self.ContainsValue( value );
    }
    public virtual IEnumerator GetEnumerator() {
      return self.GetEnumerator();
    }
    public virtual void Undefine( ISymbol key ) {
      self.Remove( key.Name );
    }

  }
}
