

namespace TtLisp {
  abstract class SymbolicExpression {}
  interface ISymbol {}
  class     List     : SymbolicExpression, ISymbol {}
  class     Nil      : List {}
  class     Atom     : SymbolicExpression {}
  class     True     : Atom {}
  class     Symbol   : Atom, ISymbol {}
  class     Numeric  : Atom {}
  class     Integer  : Numeric {}
  class     LString  : Atom {}
  class     Function : Atom {}
  class     Lambda   : Function {}
  class     SpecialForm : Function {}
  class     Macro    : Function {}

  abstract class SymbolicExpression {
    bool IsNil { get; }
    bool IsNotNil { get; }
    SymbolicExpression ToEvaluated( Env env );
  }

  class Env {
    SymbolTable        Symbols { get; }
    FunctionTable      Functions { get; }
    SymbolicExpression Eval( SymbolicExpression form );
  }

  class Parser {
  }
  
  // ֐
  car;
  cdr;
  cons;
  quote;
  eq;
  cond;
  atom;
  setq;
  set;
  defun;
  defmacro;
  lambda;
  function;
  funcall;
  apply;
  eval;
  let;
  if;
  progn;
  
}




