// Symbol.cs
using System;

namespace TtLisp {
  public interface ISymbol {
    string Name { get; }
  }

  public class Symbol : Atom, ISymbol {
    // -- instance -------------------------------------------------------
    private string name;

    public Symbol( string name ) {
      this.name = name;
    }

    public string Name { get { return this.name; } }

    public override SymbolicExpression ToEvaluated( Env env ) {
      return env.SymbolTable[this];
    }

    protected override bool LispEqThisType( SymbolicExpression other ) {
      return other is ISymbol && this.Name.Equals( ((ISymbol)other).Name );
    }

    public override string ToString() {
      return this.Name;
    }

  }
}
