// SymbolicExpression.cs
using System;


namespace TtLisp {
  public abstract class SymbolicExpression {
    // -- static ---------------------------------------------------------
    public static SymbolicExpression NIL { get { return Nil.NIL; } }

    // -- instance -------------------------------------------------------
    public abstract SymbolicExpression ToEvaluated( Env env );

    public bool LispEq( SymbolicExpression other ) {
      if ( this is Nil ) { return other is Nil; }
      if ( other is Nil ) { return false; }
      return this.LispEqThisType( other );
    }

    protected virtual bool LispEqThisType( SymbolicExpression other ) {
      return Object.ReferenceEquals( this, other );
    }

    public abstract override string ToString();

  }
}
